Often times we'll need to select one or many elements and while there are many ways to do so, some are better than others for different uses.

## document.getElementById()

* [MDN Documentation](https://developer.mozilla.org/en-US/docs/Web/API/Document/getElementById)

Written `document.getElementById(selector)`, this method finds and returns 1 element by its element Id.

For example, take the following HTML element:
```html
<div id='header-bar'></div>
```
If you wanted to select this element you could write:
```javascript
const headerBar = document.getElementById('header-bar');
```

## document.getElementsByClassName()

* [MDN Documentation](https://developer.mozilla.org/en-US/docs/Web/API/Document/getElementsByClassName)

Written `document.getElementsByClassName(selector)`, this method finds and returns multiple elements by the element tag.

For example, take the following HTML elements:
```html
<div class='menu-item'></div>
<div class='menu-item'></div>
```
If you wanted to selected all the list items, you could write:
```javascript
const menuItems = document.getElementsByTagName('menu-item');
```

## document.getElementsByName()

* [MDN Documentation](https://developer.mozilla.org/en-US/docs/Web/API/Document/getElementsByName)

Written `document.getElementsByName(selector)`, this method finds and returns multiple elements by the name attribute.

For example, take the following HTML elements:
```html
<div name='menu-item'></div>
<div name='menu-item'></div>
```
If you wanted to selected all the list items, you could write:
```javascript
const menuItems = document.getElementsByName('menu-item');
```

## document.querySelector()

* [MDN Documentation](https://developer.mozilla.org/en-US/docs/Web/API/Document/querySelector)

Written `document.querySelector(selector)`, this method searches for a single instance of an element by its CSS selector.

For example, to select the following element:
```html
<div class='menu-item' id='home-item'></div>
```

You could write any of the following:
```javascript
const menuItem = document.querySelector('.menu-item');
const homeItem = document.querySelector('#home-item');
const divItem = document.querySelector('div');
```

## document.querySelectorAll()

* [MDN Documentation](https://developer.mozilla.org/en-US/docs/Web/API/Document/querySelectorAll)

Written `document.querySelectorAll(selector)`, this method acts the same as document.querySelector() but returns an array of all found items.

For example, to select the following elements:
```html
<div class='menu-item'></div>
<div class='menu-item'></div>
```

You could write any of the following:
```javascript
const menuItem = document.querySelectorAll('.menu-item');
const divItem = document.querySelectorAll('div');
```


export const section = 'Vanilla JavaScript';
export const name = 'Selecting Elements';
export const slug = 'selecting-elements';
